VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "XLUpgrade"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' 2001 Gevira Technology Inc.
'Description: A class component to upgrade old Excel files to latest version
'
'Author: Mathew George          Created: February 1, 2000
'Module History
'Version    Date        Who             Description
'

Private Declare Function GetTempPath Lib "kernel32" _
  Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Private Property Get TempPath() As String
  ' Returns : The path of the temporary directory
  ' Source: Total Visual SourceBook 2000

  Dim lngRet As Long
  Dim strTempPath As String
  
  On Error GoTo PROC_ERR
  
  strTempPath = Space$(255)
  lngRet = GetTempPath(Len(strTempPath), strTempPath)
  
  TempPath = TrimNulls(strTempPath)

PROC_EXIT:
  Exit Property

PROC_ERR:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , _
    "TempPath"
  Resume PROC_EXIT

End Property

Public Function UpgradeFiles(ByRef sfilename() As String) As Integer
'This will upgrade a number of files at the same time when passed
'an array. Using this call is faster than calling upgradeFile in a loop
'Mathew George 2/1/2000

Dim xlApp As Excel.Application
Dim i As Integer, max As Integer
Dim sTmpName As String
Dim fs

On Error GoTo ERR_HANDLER
   
   'Create a new COM object from Excel
    Set xlApp = New Excel.Application
    
    'Get the total # of files passed
    max = UBound(sfilename) - 1
    If max < 0 Then
        UpgradeFiles = 0
        Exit Function
    End If
    
    'Create file system object for file operations
    Set fs = CreateObject("Scripting.FileSystemObject")
    
    'Loop thru for each file passed in the array
    For i = 0 To max
        'Create a tmp File Name
        sTmpName = TempPath & fs.GetFileName(sfilename(i))
'        MsgBox sTmpName
        'Copy the File to Temp Location
        fs.CopyFile sfilename(i), sTmpName
        'Delete original File
        fs.DeleteFile sfilename(i), True
        'Open Tmp File
        xlApp.Workbooks.Open FileName:=sTmpName
        
        'Write to Original lcoation
        xlApp.ActiveWorkbook.SaveAs FileName:=sfilename(i), FileFormat:=xlNormal, _
            Password:="", WriteResPassword:="", ReadOnlyRecommended:=False, _
            CreateBackup:=False
        'Close Workbook
        xlApp.Workbooks.Close
        'Delete Tmp File
        fs.DeleteFile sTmpName, True
    Next    'Loop for next file
    
    xlApp.Quit
    
    Set xlApp = Nothing
    Set fs = Nothing
    
    UpgradeFiles = 1     'success

Exit Function
    
ERR_HANDLER:
   xlApp.Quit
   Set xlApp = Nothing
   Set fs = Nothing
   UpgradeFiles = -1
   
End Function

Public Function UpgradeFile(ByVal sfilename As String) As Integer

Dim xlApp As Excel.Application
Dim sTmpName As String
Dim fs

On Error GoTo ERR_HANDLER
   
   'Create a new COM object from Excel
    Set xlApp = New Excel.Application
  
    'Create file system object for file operations
    Set fs = CreateObject("Scripting.FileSystemObject")
    
    'Create a tmp File Name
    sTmpName = TempPath & fs.GetFileName(sfilename)
'    MsgBox sTmpName
    
    'Copy the File to Temp Location
    fs.CopyFile sfilename, sTmpName
    'Delete original File
    fs.DeleteFile sfilename, True
    'Open Tmp File
    xlApp.Workbooks.Open FileName:=sTmpName
    
    'Write to Original lcoation
    xlApp.ActiveWorkbook.SaveAs FileName:=sfilename, FileFormat:=xlNormal, _
        Password:="", WriteResPassword:="", ReadOnlyRecommended:=False, _
        CreateBackup:=False
    'Close Workbook
    xlApp.Workbooks.Close
    'Delete Tmp File
    fs.DeleteFile sTmpName, True
    
    xlApp.Quit
    
    Set xlApp = Nothing
    Set fs = Nothing
    
    UpgradeFile = 1     'success

Exit Function
    
ERR_HANDLER:
   xlApp.Quit
   Set xlApp = Nothing
   Set fs = Nothing
   UpgradeFile = -1
   
End Function



Private Function TrimNulls(ByVal strIn As String) As String
  ' Comments  : Returns the passed string terminated at the first null
  ' Parameters: strIn - Value to parse
  ' Returns   : Parsed string
  ' Source    : Total Visual SourceBook 2000
  '
  Dim intPos As Integer
  
  On Error GoTo PROC_ERR
    
  intPos = InStr(strIn, vbNullChar)
  
  If intPos = 0 Then
    ' No nulls in the string, just return it as is
    TrimNulls = strIn
  Else
    If intPos = 1 Then
      ' If the null character is at the first position, the
      ' entire string is a null string, so return a zero-length string
      TrimNulls = ""
    Else
      ' Not at the first position, so return the contents up
      ' to the occurrence of the null character
      TrimNulls = Left$(strIn, intPos - 1)
    End If
  End If
    
PROC_EXIT:
  Exit Function
  
PROC_ERR:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , _
    "TrimNulls"
  Resume PROC_EXIT
    
End Function

